__kernel void hello(__global int* screen, global char* volume, int scr_width, int scr_height, int vol_width, int vol_height, int vol_depth, int ptime)
{
	int x = get_global_id(0);
	int y = get_global_id(1);
	int t = ptime >> 4;

	int c = sin(x / 45.0) * 63.0 + sin(y / 80.0) * 120.0 + sin((x+y+t) / 37.0) * 142.0 + sin((sin(x/38.0) * 12.0 + sin((x-y+t+t) / 16.0) * 37.0) / 55.0) * 17.0;
	c = c & 511;
	if (c > 255) c = 511 - c;

	screen[y * scr_width + x] = (c << 16) | (c << 8) | c;
}
